﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using igEditors = Infragistics.Controls.Editors;

namespace XamComboEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private int currentlySelectedItemIndex = -1;

        public MainWindow()
        {
            InitializeComponent();
            var productViewModel = this.Resources["productViewModel"] as ProductViewmodel;
            LoadProducts(productViewModel);
        }

        private void LoadProducts(ProductViewmodel productViewModel)
        {
            for (int i = 0; i < 10; i++)
            {
                productViewModel.Products.Add(
                    new Product
                    {
                        Name = "Product" + i,
                        Price = 10 + i,
                    });
            }
        }

        private void xamComboEditor_DropDownOpening(object sender, System.ComponentModel.CancelEventArgs e)
        {
            foreach (var item in (sender as igEditors.XamComboEditor).Items)
            {
                if (item.IsSelected == true)
                {
                    currentlySelectedItemIndex = (sender as igEditors.XamComboEditor).Items.IndexOf(item);
                }
            }
        }

        private void xamComboEditor_SelectionChanged(object sender, EventArgs e)
        {
            if (currentlySelectedItemIndex != -1)
            {
                int itemIndexBeingSelected = (sender as igEditors.XamComboEditor).SelectedIndex;
                if (itemIndexBeingSelected == -1)
                {
                    (sender as igEditors.XamComboEditor).SelectedIndex = currentlySelectedItemIndex;
                }
            }
        }
    }

    public class Product
    {
        public string Name
        {
            get;
            set;
        }

        public double Price
        {
            get;
            set;
        }
    }

    public class ProductViewmodel
    {
        public ObservableCollection<Product> Products { get; private set; }

        public ProductViewmodel()
        {
            Products = new ObservableCollection<Product>();
        }
    }
}
